import subprocess
import time
from TOOLS.dbConnection import exec_sqlfile, connect_to_database
from ETL.getEstaciones import get_estaciones
from ETL.getHistoricoDiario import get_historico_aemet
from ETL.getPortsData import get_ports_data
from ETL.getSpotRelations import get_spot_relations


subprocess.call(["docker-compose", "-f", "docker-compose.yml", "up", "-d"])
time.sleep(3)
print("docker up!")

print("getting data...")
get_estaciones()
get_spot_relations()
get_historico_aemet()
get_ports_data()
print("ETL proccess done!")

print("setup dataset for labeling...")
conn = connect_to_database()
cur = conn.cursor()
exec_sqlfile("./SQL/create_wc_labeldataset.sql", cur)
conn.commit()
cur.close()
conn.close()
print("setup dataset done!")


