from TOOLS.dbConnection import connect_to_database
from TOOLS.formulas import transform_to_grades
from constants import API_KEY, SERVER_URL

import psycopg2
import requests
import json


def get_estaciones():
    url = SERVER_URL + "/valores/climatologicos/inventarioestaciones/todasestaciones/"
    db_connection = connect_to_database()
    cur = db_connection.cursor()

    cur.execute("""delete from aemet_estacion cascade""")

    querystring = {"api_key": API_KEY}
    headers = {'cache-control': "no-cache"}
    response = requests.request("GET", url, headers=headers, params=querystring)

    # Comprobar si la solicitud fue exitosa (estado 200)
    if response.status_code == 200:
        # Obtener la URL real de los datos
        url_data = response.json()["datos"]
        # Realizar una nueva solicitud GET a la URL de los datos
        data_response = requests.get(url_data, headers=headers, params=querystring)
        if data_response.status_code == 200:
            # Convertir la respuesta JSON a un objeto Python
            data_json = json.loads(data_response.text)
            # Iterar sobre los datos y mostrar la información
            for estacion in data_json:
                # Insertar los datos de la estación en la tabla correspondiente
                try:
                    print(estacion)
                    (estacion["latitud"],
                     estacion["longitud"]) = transform_to_grades(estacion["latitud"],
                                                                 estacion["longitud"])
                    print(estacion)
                    cur.execute("""
                    INSERT INTO AEMET_ESTACION (latitud, provincia, altitud, indicativo, nombre, indsinop, longitud)
                        VALUES (%s, %s, %s, %s, %s, %s, %s)
                    """, (estacion["latitud"], estacion["provincia"], estacion["altitud"], estacion["indicativo"],
                          estacion["nombre"], estacion["indsinop"], estacion["longitud"]))
                    print("Datos de la estación", estacion["indicativo"], "insertados correctamente.")
                except psycopg2.Error as e:
                    print("Error al insertar datos de la estación:", estacion["indicativo"], e)

            db_connection.commit()
            cur.close()
            db_connection.close()

    else:
        print("Error", response.status_code)
