import psycopg2
import pandas as pd
from constants import DB_NAME, DB_USER, DB_PASSWORD, DB_HOST, DB_PORT


def connect_to_database():
    try:
        conn = psycopg2.connect(
            dbname=DB_NAME, user=DB_USER, password=DB_PASSWORD, host=DB_HOST, port=DB_PORT
        )
        print("Connected to:", DB_NAME)
        return conn
    except psycopg2.DatabaseError as e:
        print("Error connecting to :", DB_NAME, e)
        return None


def exec_sqlfile(sqlfile, cur):
    try:
        # Leer el contenido del archivo SQL
        with open(sqlfile, 'r') as f:
            query = f.read()

        # Ejecutar el contenido del archivo SQL
        cur.execute(query)

    except Exception as e:
        print("Error al ejecutar el archivo SQL:", e)


def get_queryresults(sqlfile):
    try:
        conn = connect_to_database()
        cur = conn.cursor()
        with open(sqlfile, 'r') as file:
            sql_query = file.read()
        cur.execute(sql_query)
        columns = [desc[0] for desc in cur.description]
        data = cur.fetchall()
        df = pd.DataFrame(data, columns=columns)
        return df
    except Exception as e:
        print("Error al ejecutar el archivo SQL:", e)
