package tfg.windcaddy.Backend.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import tfg.windcaddy.Backend.domain.ToLabelEntity;
import tfg.windcaddy.Backend.domain.WcLabeldatasetEntity;
import tfg.windcaddy.Backend.repository.ToLabelRepository;
import tfg.windcaddy.Backend.repository.WcLabeldatasetRepository;


import java.util.List;
import java.util.Optional;
import java.util.Random;

@Service
public class ToLabelService {

    private final ToLabelRepository toLabelRepository;
    private final WcLabeldatasetRepository wcLabeldatasetRepository;

    @Autowired
    public ToLabelService(ToLabelRepository toLabelRepository, WcLabeldatasetRepository wcLabeldatasetRepository) {
        this.toLabelRepository = toLabelRepository;
        this.wcLabeldatasetRepository = wcLabeldatasetRepository;
    }

    public ToLabelEntity saveOrUpdate(ToLabelEntity entity) {
        return toLabelRepository.save(entity);
    }

    public Optional<ToLabelEntity> findById(int id) {
        return toLabelRepository.findById(id);
    }

    public List<ToLabelEntity> findAll() {
        return toLabelRepository.findAll();
    }

    public void deleteById(int id) {
        toLabelRepository.deleteById(id);
    }

    public WcLabeldatasetEntity getRandomEntity() {
        List<Long> toLabelIds = toLabelRepository.getRecordsToLabel(); // Suponiendo que getRecordsToLabel() devuelve una lista de Longs
        if (toLabelIds.isEmpty()) {
            return null; // Retorna null si no hay entidades disponibles
        }

        // Obtener un índice aleatorio dentro del rango de la lista de IDs
        Random random = new Random();
        int randomIndex = random.nextInt(toLabelIds.size());

        // Obtener el ID aleatorio seleccionado
        Long randomId = toLabelIds.get(randomIndex);

        // Utiliza el ID para buscar la entidad correspondiente en la base de datos
        Optional<WcLabeldatasetEntity> optionalEntity = wcLabeldatasetRepository.findById(randomId.intValue());


        // Retorna la entidad si se encuentra, de lo contrario, retorna null
        return optionalEntity.orElse(null);
    }

}
