package tfg.windcaddy.Backend.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import tfg.windcaddy.Backend.domain.WcLabeldatasetEntity;
import tfg.windcaddy.Backend.repository.WcLabeldatasetRepository;

import java.util.List;
import java.util.Optional;
import java.util.Random;

@Service
public class WcLabeldatasetService {

    private final WcLabeldatasetRepository repository;

    @Autowired
    public WcLabeldatasetService(WcLabeldatasetRepository repository) {
        this.repository = repository;
    }

    public List<WcLabeldatasetEntity> getAllEntities() {
        return repository.findAll();
    }

    public Optional<WcLabeldatasetEntity> getEntityById(int id) {
        return repository.findById(id);
    }

    public Optional<WcLabeldatasetEntity> getEntityToLabel() {
        return null;
    }



    public WcLabeldatasetEntity createEntity(WcLabeldatasetEntity entity) {
        return repository.save(entity);
    }
    public List<Long> getRecordsToLabel() { return repository.getRecordsToLabel(); }
    public WcLabeldatasetEntity updateEntity(int id, WcLabeldatasetEntity entity) {
        if (repository.existsById(id)) {
            entity.setId(id);
            return repository.save(entity);
        } else {
            throw new IllegalArgumentException("La entidad con el ID proporcionado no existe");
        }
    }

    public void deleteEntity(int id) {
        if (repository.existsById(id)) {
            repository.deleteById(id);
        } else {
            throw new IllegalArgumentException("La entidad con el ID proporcionado no existe");
        }
    }
}
