package tfg.windcaddy.Backend.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import tfg.windcaddy.Backend.domain.WcSpotEntity;
import tfg.windcaddy.Backend.repository.WcSpotRepository;

import java.util.List;
import java.util.Optional;

@Service
public class WcSpotService {
    private final WcSpotRepository wcSpotRepository;

    @Autowired
    public WcSpotService(WcSpotRepository wcSpotRepository) {
        this.wcSpotRepository = wcSpotRepository;
    }

    public List<WcSpotEntity> getAllWcSpots() {
        return wcSpotRepository.findAll();
    }

    public Optional<WcSpotEntity> getWcSpotById(int id) {
        return wcSpotRepository.findById(id);
    }

    public WcSpotEntity saveWcSpot(WcSpotEntity wcSpot) {
        return wcSpotRepository.save(wcSpot);
    }

    public void deleteWcSpotById(int id) {
        wcSpotRepository.deleteById(id);
    }

    // Puedes agregar más métodos según sea necesario para tu lógica de negocio
}
